---
title: shape-rendering
slug: Web/SVG/Attribute/shape-rendering
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>shape-rendering</code></strong> attribute provides hints to the renderer about what tradeoffs to make when rendering shapes like paths, circles, or rectangles.</p>

<p class="note"><strong>Note:</strong> As a presentation attribute, <code>shape-rendering</code> can be used as a CSS property.</p>

<p>As a presentation attribute, it can be applied to any element but it has effect only on the following seven elements: {{SVGElement("circle")}}, {{SVGElement("ellipse")}}, {{SVGElement("line")}}, {{SVGElement("path")}}, {{SVGElement("polygon")}}, {{SVGElement("polyline")}}, and {{SVGElement("rect")}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css notranslate">html, body, svg {
  height: 100%;
}</pre>
</div>

<pre class="brush: html; highlight[2,3] notranslate">&lt;svg viewBox="0 0 420 200" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;circle cx="100" cy="100" r="100" shape-rendering="geometricPrecision"/&gt;
  &lt;circle cx="320" cy="100" r="100" shape-rendering="crispEdges"/&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample("topExample", "420", "220")}}</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>auto</code> | <code>optimizeSpeed</code> | <code>crispEdges</code> | <code>geometricPrecision</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>auto</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>discrete</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>auto</code></dt>
 <dd>This value indicates that the user agent shall make appropriate tradeoffs to balance speed, crisp edges and geometric precision, but with geometric precision given more importance than speed and crisp edges.</dd>
 <dt><code>optimizeSpeed</code></dt>
 <dd>This value indicates that the user agent shall emphasize rendering speed over geometric precision and crisp edges. This option will sometimes cause the user agent to turn off shape anti-aliasing.</dd>
 <dt><code>crispEdges</code></dt>
 <dd>This value indicates that the user agent shall attempt to emphasize the contrast between clean edges of artwork over rendering speed and geometric precision. To achieve crisp edges, the user agent might turn off anti-aliasing for all lines and curves or possibly just for straight lines which are close to vertical or horizontal. Also, the user agent might adjust line positions and line widths to align edges with device pixels.</dd>
 <dt><code>geometricPrecision</code></dt>
 <dd>Indicates that the user agent shall emphasize geometric precision over speed and crisp edges.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "painting.html#ShapeRenderingProperty", "shape-rendering")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "painting.html#ShapeRenderingProperty", "shape-rendering")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.presentation.shape-rendering")}}</p>
